import { reactive as M, defineComponent as yl, ref as m, computed as G, onMounted as _l, watchEffect as Fl, toRefs as El, resolveComponent as b, resolveDirective as Pe, openBlock as s, createBlock as v, normalizeStyle as Cl, unref as X, withCtx as n, createVNode as d, withDirectives as q, createElementVNode as de, renderSlot as A, withKeys as He, createElementBlock as x, Fragment as k, renderList as Y, mergeProps as B, createCommentVNode as T, vShow as Dl, createTextVNode as W, toDisplayString as be, createSlots as Se, resolveDynamicComponent as Vl, normalizeProps as wl, guardReactiveProps as Bl } from "vue";
import { ElNotification as Pl, ElMessage as Hl, ElMessageBox as he } from "element-plus";
import { useRoute as Sl } from "vue-router";
const I = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Al(u = { debug: !1 }) {
  const p = M({
    hooks: {}
  });
  return Object.keys(u).forEach((t) => {
    t !== "debug" && (p.hooks[t] = u[t]);
  }), {
    hookHandler: (t, D) => {
      let E = !1;
      try {
        u.debug && (console.group("DeBug\uFF1A", t), console.table(D.Data), console.groupEnd()), E = p.hooks[t](D);
      } catch {
        E = !0;
      }
      return E;
    }
  };
}
const oe = (u, p = "success") => {
  Pl({
    title: u,
    type: p,
    offset: 70,
    duration: 2500
  });
};
function U(u) {
  let p;
  try {
    p = Array.isArray(u) ? [] : {}, u === null && (p = null);
  } catch {
    p = {};
  }
  for (const h in u)
    typeof u[h] == "object" ? p[h] = U(u[h]) : p[h] = u[h];
  return p;
}
function se(u, p) {
  let h = U(u);
  for (var t in p)
    h.hasOwnProperty(t) && typeof p[t] == "object" ? h[t] = se(h[t], p[t]) : h[t] = p[t];
  return h;
}
function Ml(u, p) {
  let h = {}, t = Object.getOwnPropertyNames(u), D = Object.getOwnPropertyNames(p);
  return t.length === D.length && t.forEach((E) => {
    u[E] !== p[E] && (h[E] = p[E]);
  }), h;
}
const xl = {
  debug: !1,
  IssearchForm: !0,
  labelWidth: 120,
  expand: !0,
  menuWidth: 310,
  menuAlign: "left",
  modalWidth: 800,
  editFooterButton: !0,
  pageSizes: [10, 20, 50, 100],
  Pagination: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  PaginationLayout: "->,total, sizes, prev, pager, next, jumper",
  queryAfterMount: !1,
  openMultipleSelection: !1,
  destroyOnClosModal: !0,
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
};
let P = M({});
function z(...u) {
  P.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...u);
}
const Ae = (u) => {
  P = se(xl, u);
};
Ae({});
const kl = /* @__PURE__ */ W(" \u65B0\u589E "), Ul = /* @__PURE__ */ W(" \u6279\u91CF\u5220\u9664 "), Nl = { class: "quick-search-area" }, Rl = { style: { display: "flex", "justify-content": "flex-end" } }, zl = /* @__PURE__ */ W("\u53D6\u6D88"), $l = /* @__PURE__ */ W("\u63D0\u4EA4"), Kl = /* @__PURE__ */ yl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    tableHeight: null,
    queryAfterMount: { type: Boolean, default: () => P.queryAfterMount },
    openMultipleSelection: { type: Boolean, default: () => P.openMultipleSelection },
    expand: { type: Boolean, default: () => P.expand },
    PaginationLayout: { default: () => P.PaginationLayout },
    fullscreen: { type: Boolean },
    destroyOnClosModal: { type: Boolean, default: () => P.destroyOnClosModal },
    modalWidth: { default: () => P.modalWidth },
    closeOnPressEscape: { type: Boolean },
    editFooterButton: { type: Boolean, default: () => P.editFooterButton },
    permission: { default: () => P.permissions }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(u, { expose: p, emit: h }) {
    const t = u;
    z("\u521D\u59CB\u5316\u540E\u7684\u3010\u7CFB\u7EDF\u53C2\u6570\u3011", P), z("\u3010Props\u53C2\u6570\u3011", t);
    const D = Sl(), E = m(), N = m(), ye = m(), _e = m(), L = m("add"), $ = m(!1), Z = m(!1), R = m(!1), Me = m(t.editFooterButton), f = M({ ...se(P, t.source.options) }), { hookHandler: K } = Al(t.hooks);
    let O = G(() => f.CrudRequest);
    const V = m({ filter: {}, editor: {}, column: {} }), xe = m(), Fe = m(), Ee = m(), ie = m(), Ce = m(), F = m({}), ee = m({}), y = m({}), ce = m({}), le = m([]), ke = m([]), w = M({
      current: f.Pagination.current,
      pageSize: f.Pagination.pageSize,
      total: f.Pagination.total
    }), Q = m(0), pe = m(0), fe = m(0), ae = m(0);
    if ((() => {
      const { filter: e, editor: l, column: o, columns: i } = t.source;
      let H = {};
      e.forEach((_) => {
        i[_].searchDefaultValue !== void 0 ? H[_] = i[_].searchDefaultValue : H[_] = void 0, V.value.filter[_] = i[_];
      }), ie.value = U(H), F.value = U(ie.value);
      let J = {};
      l.forEach((_) => {
        i[_].addDefaultValue !== void 0 ? J[_] = i[_].addDefaultValue : J[_] = void 0, V.value.editor[_] = i[_];
      }), Ce.value = U(J), o.forEach((_) => {
        V.value.column[_] = i[_];
      }), xe.value = i;
    })(), D.params.data) {
      z("\u8DEF\u7531\u4F20\u53C2\uFF1A", D.params.data);
      let e = D.params.data, l = JSON.parse(e);
      ee.value = se(ee.value, l), z("searchFormValue", ee);
    }
    const Ue = G(() => {
      let e = {};
      const l = ["el-input", "el-input-number", "el-select", "el-date-picker"];
      return t.source.filter.forEach((o) => {
        l.includes(V.value.filter[o].type) && (e[o] = V.value.filter[o]);
      }), e;
    }), Ne = G(() => {
      let e = {};
      const l = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-cascader", "el-upload"];
      return t.source.editor.forEach((o) => {
        l.includes(V.value.editor[o].type) && j(V.value.editor[o], "visible") && (e[o] = V.value.editor[o]);
      }), e;
    }), Re = G(() => ({ ...t.wrapperStyle })), ze = G(() => {
      const e = m(0);
      return t.tableHeight ? e.value = t.tableHeight : f.IssearchForm ? e.value = pe.value : e.value = fe.value, e.value;
    }), De = G(() => t.fullscreen ? ae.value - 50 : ae.value > 250 ? ae.value - Q.value * 0.3 : 250);
    _l(() => {
      Q.value = document.documentElement.clientHeight, pe.value = Q.value - 50 - 20 - 40 - 56 - N.value.clientHeight - E.value.clientHeight, fe.value = Q.value - 50 - 20 - 40 - 56 - N.value.clientHeight, ae.value = Q.value - 54 - 62, t.queryAfterMount && C(), t.watchData && t.watchData.forEach((e) => {
        Fl(() => {
          y.value[e.id] && (z("\u76D1\u542C\u7684id\u6570\u636E", y.value[e.id]), e.data.forEach((l) => {
            l.data[e.id] = y.value[e.id], z("\u76D1\u542C\u7684\u6570\u636E\u8BF7\u6C42", l), Qe(l);
          }));
        });
      }), z("onMounted", g), z("Hight", { clientHeight: Q, OpenSearchFormtableMaxHeight: pe, CloseSearchFormtableMaxHeight: fe, EditFormMaxHeight: ae });
    });
    const me = (e) => {
      let l = {};
      return t.rowKey && (l[t.rowKey] = e[t.rowKey]), t.rowKeys && t.rowKeys.forEach((o) => {
        l[o] = e[o];
      }), l;
    }, ue = (e) => e.formProps && e.formProps.type ? e.range ? e.formProps.type + "range" : e.formProps.type : "date", j = (e, l) => {
      if (l === "disabled")
        return typeof e.disabled == "function" ? e.disabled(g, L.value) : !1;
      if (l === "visible")
        return typeof e.visible == "function" ? e.visible(g, L.value) : !0;
    }, $e = (e, l, o, i) => {
      h("cell-click", { row: e, column: l, cell: o, event: i });
    }, Ke = (e, l, o) => {
      h("row-contextmenu", { row: e, column: l, event: o }, g);
    }, Oe = (e) => {
      le.value = e;
    }, qe = (e) => {
      let l = { ...e };
      return Object.keys(l).forEach((o) => {
        typeof l[o] == "function" && (l[o] = l[o].bind(this, g));
      }), l;
    }, Te = (e, l) => {
      let o = { ...e };
      return Object.keys(o).forEach((i) => {
        typeof o[i] == "function" && (o[i] = o[i].call(this, g, l));
      }), o;
    }, Ie = (e) => {
      w.pageSize = e, C();
    }, We = (e) => {
      w.current = e, w.current != null && C();
    }, Le = (e, l, o) => {
      if (l.type === "el-select") {
        const i = l.formProps.options.findIndex((H) => H.value == e.row[o]);
        return i === -1 ? e.row[o] : l.formProps.options[i].label;
      } else
        return e.row[o];
    }, Qe = (e) => {
      O.value({ url: e.url, name: e.name, data: e.data }).then((l) => {
        V.value.editor[e.key].formProps.options = l.data.map((o) => {
          if (typeof e.label == "string")
            return {
              value: o[e.value],
              label: o[e.label]
            };
          if (typeof e.label == "object")
            return {
              value: o[e.value],
              label: o[e.label[0]] + "--" + o[e.label[1]]
            };
        });
      });
    }, C = () => {
      Z.value = !0;
      const e = M({
        ...F.value,
        ...ee.value
      });
      for (const l in e)
        Object.prototype.hasOwnProperty.call(e, l) && typeof e[l] == "string" && (e[l] = e[l].trim(), e[l] === "" && (e[l] = void 0));
      !K(I.beforeQueryHandler, { CrudState: g, Data: e }) || O.value({
        url: t.url,
        name: f.apiName.query,
        data: {
          pagenum: w.current,
          pagesize: w.pageSize,
          ...e
        }
      }).then((l) => {
        const { data: o, page: i } = l;
        setTimeout(() => {
          je(o, e), w.total = i.total, Z.value = !1;
        }, 50);
      }).catch(() => {
        Z.value = !1;
      });
    }, je = (e, l) => {
      Object.keys(l).filter((i) => l[i] != null).length == 0 && (Ee.value = e), Ee.value = U(e), K(I.afterQueryHandler, { CrudState: g, Data: e }) && (Fe.value = U(e));
    }, Je = () => {
      F.value = U(ie.value), C();
    }, Ge = () => {
      y.value = U(Ce.value);
      const e = M({ ...y.value });
      !K(I.beforeAddHandler, { CrudState: g, Data: e }) || (L.value = "add", $.value = !0);
    }, Xe = (e) => {
      const l = M({
        ...e
      });
      !K(I.beforeEditHandler, { CrudState: g, Data: l }) || (Object.keys(l).forEach((o) => {
        y.value[o] = l[o], ce.value[o] = l[o];
      }), L.value = "edit", $.value = !0);
    }, ne = async (e) => {
      !e || await e.validate((l) => {
        if (l) {
          const o = M({
            ...y.value
          });
          if (!K(I.beforeSubmitHandler, { CrudState: g, Data: o }))
            return;
          g.Mode === "add" ? Ye(o) : Ze(o);
        }
      });
    }, Ye = (e) => {
      R.value = !0;
      let l = e;
      e.FormData instanceof FormData && (l = e.FormData), O.value({ url: t.url, name: f.apiName.add, data: l }).then(() => {
        $.value = !1, oe("\u65B0\u589E\u6210\u529F"), C(), R.value = !1;
      }).catch(() => {
        R.value = !1;
      });
    }, Ze = (e) => {
      R.value = !0;
      let l = e;
      if (e.FormData instanceof FormData)
        l = e.FormData;
      else {
        const o = Ml(ce.value, l);
        if (JSON.stringify(o) === "{}")
          return R.value = !1, Hl({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        l = {
          ...me(e),
          ...o
        };
      }
      O.value({ url: t.url, name: f.apiName.edit, data: l }).then(() => {
        $.value = !1, oe("\u4FEE\u6539\u6210\u529F"), C(), R.value = !1;
      }).catch(() => {
        R.value = !1;
      });
    }, el = (e) => {
      he.confirm(`\u786E\u5B9A\u8981 \u201C${e.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = M({
          row: { ...e },
          ...me(e),
          deleteFlag: e.deleteFlag == 0 ? 1 : 0
        });
        !K(I.beforedisabledHandler, { CrudState: g, Data: l }) || O.value({
          url: t.url,
          name: f.apiName.deleteFlag,
          data: l
        }).then(() => {
          oe(`\u6570\u636E${e.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), C();
        });
      }).catch(() => {
      });
    }, ll = (e) => {
      he.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = M({
          row: { ...e },
          ...me(e)
        });
        !K(I.beforeDeteleHandler, { CrudState: g, Data: l }) || O.value({
          url: t.url,
          name: f.apiName.delete,
          data: l
        }).then(() => {
          oe("\u5220\u9664\u6210\u529F"), C();
        });
      }).catch(() => {
      });
    }, al = () => {
      he.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const e = le.value.map((l) => l[t.rowKey]);
        O.value({
          url: t.url,
          name: f.apiName.remove,
          data: { [t.rowKey]: e, selection: le.value }
        }).then(() => {
          oe("\u6279\u91CF\u5220\u9664\u6210\u529F"), le.value = [], ye.value.clearSelection(), C();
        });
      }).catch(() => {
      });
    }, g = M({
      ElementArrs: V,
      searchModel: F,
      searchFormValue: ee,
      editModel: y,
      editFormValue: ce,
      uploadFiles: ke,
      tableLoading: Z,
      Pagination: w,
      Mode: L,
      queryRecord: C
    });
    return p({
      ...El(g)
    }), (e, l) => {
      const o = b("el-input"), i = b("el-form-item"), H = b("el-col"), J = b("el-input-number"), _ = b("el-option"), Ve = b("el-select"), ve = b("el-date-picker"), tl = b("el-row"), we = b("el-form"), ol = b("el-collapse-transition"), S = b("el-button"), ul = b("el-empty"), re = b("el-table-column"), nl = b("el-descriptions-item"), rl = b("el-descriptions"), dl = b("el-button-group"), sl = b("el-table"), il = b("el-pagination"), cl = b("el-cascader"), pl = b("plus"), fl = b("el-icon"), ml = b("el-upload"), vl = b("el-scrollbar"), Be = b("el-card"), bl = b("el-dialog"), te = Pe("permission"), hl = Pe("loading");
      return s(), v(Be, {
        style: Cl([{ border: "0" }, X(Re)])
      }, {
        default: n(() => [
          d(ol, null, {
            default: n(() => [
              q(de("div", {
                id: "plain",
                ref_key: "searchFormRef",
                ref: E
              }, [
                A(e.$slots, "search-form", {
                  editModel: F.value,
                  queryRecord: C,
                  CrudState: g
                }, void 0, !0),
                d(we, {
                  model: F.value,
                  "label-width": f.labelWidth,
                  onKeyup: He(C, ["enter", "native"])
                }, {
                  default: n(() => [
                    d(tl, null, {
                      default: n(() => [
                        A(e.$slots, "search-form-top", { CrudState: g }, void 0, !0),
                        (s(!0), x(k, null, Y(X(Ue), (a, r) => (s(), x(k, null, [
                          a.type === "el-input" ? (s(), v(H, {
                            key: 0,
                            xs: 6,
                            sm: 6,
                            md: 6,
                            lg: 6
                          }, {
                            default: n(() => [
                              d(i, {
                                label: a.label
                              }, {
                                default: n(() => [
                                  d(o, B({
                                    style: { width: "100%" },
                                    modelValue: F.value[r],
                                    "onUpdate:modelValue": (c) => F.value[r] = c,
                                    clearable: "",
                                    placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                  }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1024)) : a.type === "el-input-number" ? (s(), v(H, {
                            key: 1,
                            xs: 6,
                            sm: 6,
                            md: 6,
                            lg: 6
                          }, {
                            default: n(() => [
                              d(i, {
                                label: a.label
                              }, {
                                default: n(() => [
                                  d(J, B({
                                    style: { width: "100%" },
                                    modelValue: F.value[r],
                                    "onUpdate:modelValue": (c) => F.value[r] = c,
                                    placeholder: "\u8BF7\u8F93\u5165"
                                  }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1024)) : a.type === "el-select" ? (s(), v(H, {
                            key: 2,
                            xs: 6,
                            sm: 6,
                            md: 6,
                            lg: 6
                          }, {
                            default: n(() => [
                              d(i, {
                                label: a.label
                              }, {
                                default: n(() => [
                                  d(Ve, B({
                                    style: { width: "100%" },
                                    modelValue: F.value[r],
                                    "onUpdate:modelValue": (c) => F.value[r] = c,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9"
                                  }, a.formProps), {
                                    default: n(() => [
                                      (s(!0), x(k, null, Y(a.formProps.options, (c) => (s(), v(_, {
                                        key: c.value,
                                        label: c.label,
                                        value: c.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1024)) : a.type === "el-date-picker" && ue(a).includes("range") ? (s(), v(H, {
                            key: 3,
                            xs: 12,
                            sm: 12,
                            md: 12,
                            lg: 12
                          }, {
                            default: n(() => [
                              d(i, {
                                label: a.label
                              }, {
                                default: n(() => [
                                  d(ve, B({
                                    style: { width: "100%" },
                                    modelValue: F.value[r],
                                    "onUpdate:modelValue": (c) => F.value[r] = c,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, a.formProps, {
                                    type: ue(a)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1024)) : a.type === "el-date-picker" && ue(a) ? (s(), v(H, {
                            key: 4,
                            xs: 6,
                            sm: 6,
                            md: 6,
                            lg: 6
                          }, {
                            default: n(() => [
                              d(i, {
                                label: a.label
                              }, {
                                default: n(() => [
                                  d(ve, B({
                                    style: { width: "100%" },
                                    modelValue: F.value[r],
                                    "onUpdate:modelValue": (c) => F.value[r] = c,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, a.formProps, {
                                    type: ue(a)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1024)) : T("", !0)
                        ], 64))), 256)),
                        A(e.$slots, "search-form-bottom", { CrudState: g }, void 0, !0)
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                }, 8, ["model", "label-width", "onKeyup"])
              ], 512), [
                [Dl, f.IssearchForm]
              ])
            ]),
            _: 3
          }),
          de("div", {
            ref_key: "buttonAreaRef",
            ref: N,
            class: "button_area"
          }, [
            q((s(), v(S, {
              type: "primary",
              icon: "plus",
              onClick: Ge
            }, {
              default: n(() => [
                kl
              ]),
              _: 1
            })), [
              [te, { permission: u.permission, access: [f.permission.add] }]
            ]),
            u.openMultipleSelection ? q((s(), v(S, {
              key: 0,
              disabled: le.value.length <= 0,
              type: "danger",
              icon: "delete",
              onClick: al
            }, {
              default: n(() => [
                Ul
              ]),
              _: 1
            }, 8, ["disabled"])), [
              [te, { permission: u.permission, access: [f.permission.remove] }]
            ]) : T("", !0),
            A(e.$slots, "button-area", { CrudState: g }, void 0, !0)
          ], 512),
          q((s(), v(sl, {
            ref_key: "tableRef",
            ref: ye,
            data: Fe.value,
            "row-key": u.rowKey,
            height: X(ze),
            onCellClick: $e,
            onRowContextmenu: Ke,
            onSelectionChange: Oe
          }, {
            empty: n(() => [
              d(ul, {
                "image-size": 80,
                description: "\u6682\u65E0\u6570\u636E"
              })
            ]),
            default: n(() => [
              u.openMultipleSelection ? (s(), v(re, {
                key: 0,
                type: "selection",
                width: 44
              })) : T("", !0),
              u.expand ? (s(), v(re, {
                key: 1,
                type: "expand",
                label: "###",
                width: 55
              }, {
                default: n((a) => [
                  d(rl, {
                    column: 3,
                    border: ""
                  }, {
                    default: n(() => [
                      (s(!0), x(k, null, Y(u.source.columns, (r, c) => (s(), x(k, { key: c }, [
                        r.hidden ? T("", !0) : (s(), v(nl, {
                          key: 0,
                          label: r.label
                        }, {
                          default: n(() => [
                            W(be(Le(a, r, c)), 1)
                          ]),
                          _: 2
                        }, 1032, ["label"]))
                      ], 64))), 128))
                    ]),
                    _: 2
                  }, 1024)
                ]),
                _: 1
              })) : T("", !0),
              (s(!0), x(k, null, Y(V.value.column, (a, r) => {
                var c;
                return s(), v(re, B({
                  key: r,
                  align: a.align || "left"
                }, a.tableProps, {
                  width: a.tableProps ? (c = a.tableProps) == null ? void 0 : c.width : void 0,
                  label: a.label,
                  prop: r
                }), Se({ _: 2 }, [
                  a.columnSlot ? {
                    name: "default",
                    fn: n((gl) => [
                      (s(), v(Vl(a.columnSlot.is), wl(Bl(Te(a.columnSlot, gl))), null, 16))
                    ])
                  } : void 0
                ]), 1040, ["align", "width", "label", "prop"]);
              }), 128)),
              A(e.$slots, "default", {}, void 0, !0),
              d(re, {
                align: f.menuAlign || "left",
                width: t.keyName ? f.menuWidth : f.menuWidth - 150
              }, {
                header: n(() => [
                  de("div", Nl, [
                    t.keyName ? (s(), v(o, {
                      key: 0,
                      style: { width: "150px" },
                      modelValue: F.value[t.keyName],
                      "onUpdate:modelValue": l[0] || (l[0] = (a) => F.value[t.keyName] = a),
                      placeholder: V.value.editor[t.keyName].label + "\u6A21\u7CCA\u67E5\u627E",
                      clearable: "",
                      onKeyup: He(C, ["enter", "native"])
                    }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : T("", !0),
                    d(dl, null, {
                      default: n(() => [
                        d(S, {
                          color: "#67c23a",
                          icon: "search",
                          onClick: C
                        }),
                        d(S, {
                          color: "#e6a23c",
                          icon: "refresh",
                          onClick: Je
                        }),
                        d(S, {
                          color: "#409eff",
                          icon: "expand",
                          onClick: l[1] || (l[1] = (a) => f.IssearchForm = !f.IssearchForm)
                        })
                      ]),
                      _: 1
                    })
                  ])
                ]),
                default: n((a) => [
                  A(e.$slots, "menu-top", { scope: a }, void 0, !0),
                  q((s(), v(S, {
                    plain: "",
                    type: a.row.deleteFlag ? "danger" : "success",
                    onClick: (r) => el(a.row)
                  }, {
                    default: n(() => [
                      W(be(a.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                    ]),
                    _: 2
                  }, 1032, ["type", "onClick"])), [
                    [te, { permission: u.permission, access: [f.permission.deleteFlag] }]
                  ]),
                  q(d(S, {
                    plain: "",
                    type: "primary",
                    icon: "edit",
                    onClick: (r) => Xe(a.row)
                  }, null, 8, ["onClick"]), [
                    [te, { permission: u.permission, access: [f.permission.edit] }]
                  ]),
                  q(d(S, {
                    type: "danger",
                    icon: "delete",
                    onClick: (r) => ll(a.row)
                  }, null, 8, ["onClick"]), [
                    [te, { permission: u.permission, access: [f.permission.delete] }]
                  ]),
                  A(e.$slots, "menu-bottom", { scope: a }, void 0, !0)
                ]),
                _: 3
              }, 8, ["align", "width"])
            ]),
            _: 3
          }, 8, ["data", "row-key", "height"])), [
            [hl, Z.value]
          ]),
          d(il, {
            "hide-on-single-page": "",
            currentPage: w.current,
            "onUpdate:currentPage": l[2] || (l[2] = (a) => w.current = a),
            "page-size": w.pageSize,
            "onUpdate:page-size": l[3] || (l[3] = (a) => w.pageSize = a),
            "page-sizes": f.pageSizes,
            background: "",
            layout: u.PaginationLayout,
            total: w.total,
            onSizeChange: Ie,
            onCurrentChange: We
          }, null, 8, ["currentPage", "page-size", "page-sizes", "layout", "total"]),
          d(bl, {
            "custom-class": "DialogVisible",
            ref: "dialogRef",
            modelValue: $.value,
            "onUpdate:modelValue": l[6] || (l[6] = (a) => $.value = a),
            title: L.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: f.modalWidth,
            "destroy-on-close": "",
            fullscreen: u.fullscreen,
            "close-on-click-modal": u.destroyOnClosModal
          }, Se({
            default: n(() => [
              d(Be, {
                class: "edit-form-card",
                shadow: "never"
              }, {
                default: n(() => [
                  d(vl, {
                    height: X(De),
                    "max-height": X(De)
                  }, {
                    default: n(() => [
                      A(e.$slots, "edit-form", {
                        editModel: y.value,
                        handleSubmit: ne,
                        CrudState: g
                      }, void 0, !0),
                      d(we, {
                        id: "DialogVisible-edit-form",
                        class: "edit-form",
                        ref_key: "editFormRef",
                        ref: _e,
                        model: y.value,
                        "label-width": f.labelWidth
                      }, {
                        default: n(() => [
                          A(e.$slots, "edit-form-top", {
                            editModel: y.value,
                            handleSubmit: ne,
                            CrudState: g
                          }, void 0, !0),
                          (s(!0), x(k, null, Y(X(Ne), (a, r) => (s(), x(k, { key: r }, [
                            a.type === "el-input" ? (s(), v(i, {
                              key: 0,
                              label: a.label,
                              prop: r,
                              rules: a.rules
                            }, {
                              default: n(() => [
                                d(o, B({
                                  modelValue: y.value[r],
                                  "onUpdate:modelValue": (c) => y.value[r] = c,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: j(a, "disabled")
                                }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])) : a.type === "el-input-number" ? (s(), v(i, {
                              key: 1,
                              label: a.label,
                              prop: r,
                              rules: a.rules
                            }, {
                              default: n(() => [
                                d(J, B({
                                  modelValue: y.value[r],
                                  "onUpdate:modelValue": (c) => y.value[r] = c,
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: j(a, "disabled")
                                }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])) : a.type === "el-select" ? (s(), v(i, {
                              key: 2,
                              label: a.label,
                              prop: r,
                              rules: a.rules
                            }, {
                              default: n(() => [
                                d(Ve, B({
                                  style: { width: "220px" },
                                  modelValue: y.value[r],
                                  "onUpdate:modelValue": (c) => y.value[r] = c,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: j(a, "disabled")
                                }, a.formProps), {
                                  default: n(() => [
                                    (s(!0), x(k, null, Y(a.formProps.options, (c) => (s(), v(_, {
                                      key: c.value,
                                      label: c.label,
                                      value: c.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])) : a.type === "el-date-picker" ? (s(), v(i, {
                              key: 3,
                              label: a.label,
                              prop: r,
                              rules: a.rules
                            }, {
                              default: n(() => [
                                d(ve, B({
                                  modelValue: y.value[r],
                                  "onUpdate:modelValue": (c) => y.value[r] = c,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: j(a, "disabled")
                                }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])) : a.type === "el-cascader" ? (s(), v(i, {
                              key: 4,
                              label: a.label,
                              prop: r,
                              rules: a.rules
                            }, {
                              default: n(() => [
                                d(cl, B({
                                  modelValue: y.value[r],
                                  "onUpdate:modelValue": (c) => y.value[r] = c,
                                  props: a.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: j(a, "disabled")
                                }, a.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])) : a.type === "el-upload" ? (s(), v(i, {
                              key: 5,
                              label: a.label,
                              prop: r,
                              rules: a.rules
                            }, {
                              default: n(() => [
                                d(ml, B({ action: "" }, qe(a.formProps)), {
                                  default: n(() => [
                                    a.formProps.listType !== "picture-card" ? (s(), v(S, {
                                      key: 0,
                                      type: "primary"
                                    }, {
                                      default: n(() => [
                                        W(be(a.formProps.title), 1)
                                      ]),
                                      _: 2
                                    }, 1024)) : (s(), v(fl, { key: 1 }, {
                                      default: n(() => [
                                        d(pl)
                                      ]),
                                      _: 1
                                    }))
                                  ]),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])) : T("", !0)
                          ], 64))), 128)),
                          A(e.$slots, "edit-form-bottom", {
                            editModel: y.value,
                            handleSubmit: ne,
                            CrudState: g
                          }, void 0, !0)
                        ]),
                        _: 3
                      }, 8, ["model", "label-width"])
                    ]),
                    _: 3
                  }, 8, ["height", "max-height"])
                ]),
                _: 3
              })
            ]),
            _: 2
          }, [
            Me.value ? {
              name: "footer",
              fn: n(() => [
                de("div", Rl, [
                  A(e.$slots, "edit-form-footer", { CrudState: g }, void 0, !0),
                  d(S, {
                    onClick: l[4] || (l[4] = (a) => $.value = !1)
                  }, {
                    default: n(() => [
                      zl
                    ]),
                    _: 1
                  }),
                  d(S, {
                    type: "primary",
                    loading: R.value,
                    onClick: l[5] || (l[5] = (a) => ne(_e.value))
                  }, {
                    default: n(() => [
                      $l
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "fullscreen", "close-on-click-modal"])
        ]),
        _: 3
      }, 8, ["style"]);
    };
  }
});
const Ol = (u, p) => {
  const h = u.__vccOpts || u;
  for (const [t, D] of p)
    h[t] = D;
  return h;
}, ge = /* @__PURE__ */ Ol(Kl, [["__scopeId", "data-v-30e7a2c8"]]), ql = {
  mounted(u, p, h) {
    const t = p.value.permission, D = p.value.access;
    let E = !1;
    for (let N = 0; N < D.length; N++)
      if (t.includes(D[N])) {
        E = !0;
        break;
      } else
        E = !1;
    E || u.parentNode && u.parentNode.removeChild(u);
  }
};
ge.install = (u) => {
  u.component("CrudEl", ge), u.directive("permission", ql);
};
const Ll = (u, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Ae(p), u.use(ge)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  se as DataMerger,
  U as DeepClone,
  Ae as InitSys,
  Ll as createCrudEl,
  I as hooksName,
  Ml as isObjEqual,
  Al as useHooks
};
